/*
 * Yury P. Fedorchenko 2010
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
#include <inkview.h>
#include "main.h"

extern ifont* boardf_half;

int but_inside(struct s_button* but,int x,int y){
  if(x>but->x && x<(but->x+but->size) && y>but->y && y<(but->y+but->size)) return 1;
  return 0;
}
int but_click(struct s_button* but){
  but->inv=1;
  but->pfun();
  //but_draw(but);
  return 1;
}
void but_draw(struct s_button* but){
  DrawRect(but->x,but->y,but->size,but->size,BLACK);
  if(but->inv){
    FillArea(but->x+1,but->y+1,but->size-2,but->size-2,BLACK);
    //DrawRect(but->x+2,but->y+2,but->size-4,but->size-4,BLACK);
  }
  SetFont(boardf_half,(!but->inv)?BLACK:WHITE);
  DrawString(but->x+5,but->y+5,but->name);
  if(but->inv){
    //PartialUpdateBW(but->x,but->y,but->size,but->size);
    but->inv=0;
  }
}

