/*
 * Yury P. Fedorchenko 2001-2011
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
#include "main.h"
#include <stdlib.h>

extern struct FIELD field_array[12][25];

extern struct PTS point_T_STR;

extern struct T_STR t_f[N_T_STR],*t_work;

int tetr_struct[224]={ 
 0, -1, 0,  0, 0,  1, 0,  2,//i
-2,  0,-1,  0, 0,  0, 1,  0,//i
 0, -1, 0,  0, 0,  1, 0,  2,//i
-2,  0,-1,  0, 0,  0, 1,  0,//i
 1, -1, 0, -1, 0,  0, 0,  1,//z
-1, -1,-1,  0, 0,  0, 1,  0,//z
 0, -1, 0,  0, 0,  1,-1,  1,//z
 1,  1,-1,  0, 0,  0, 1,  0,//z
 1,  1, 0, -1, 0,  0, 0,  1,//n
 1, -1,-1,  0, 0,  0, 1,  0,//n
 0, -1, 0,  0, 0,  1,-1, -1,//n
-1,  1,-1,  0, 0,  0, 1,  0,//n
-1,  0, 0,  0, 0, -1, 1, -1,//o
-1, -1,-1,  0, 0,  0, 0,  1,//o
-1,  0, 0,  0, 0, -1, 1, -1,//o
-1, -1,-1,  0, 0,  0, 0,  1,//o
 1,  0, 0,  0, 0, -1,-1, -1,//l
-1,  1,-1,  0, 0,  0, 0, -1,//l
 1,  0, 0,  0, 0, -1,-1, -1,//l
-1,  1,-1,  0, 0,  0, 0, -1,//l
-1,  0, 0,  0, 1,  0, 0,  1,//v
 0, -1, 0,  0, 1,  0, 0,  1,//v
-1,  0, 0,  0, 1,  0, 0, -1,//v
-1,  0, 0,  0, 0,  1, 0, -1,//v
 0,  0, 1,  1, 1,  0, 0,  1,//t
 0,  0, 1,  1, 1,  0, 0,  1,//t
 0,  0, 1,  1, 1,  0, 0,  1,//t
 0,  0, 1,  1, 1,  0, 0,  1};//t

//(6*2+6)*4=72
struct PTS pent_struct[][5]={
 /*F*/{{-1, 0},{ 0, 0},{ 0,-1},{ 1,-1},{ 0, 1}},
 /*L*/{{ 0,-2},{ 0,-1},{ 0, 0},{ 0, 1},{ 1, 1}},
 /*N*/{{-2, 0},{-1, 0},{ 0, 0},{ 0, 1},{ 1, 1}},
 /*P*/{{-1, 0},{ 0, 0},{ 0, 1},{ 1, 0},{ 1, 1}},
 /*Y*/{{-2, 0},{-1, 0},{ 0, 0},{ 0, 1},{ 1, 0}},
 /*Z*/{{-1,-1},{-1, 0},{ 0, 0},{ 1, 0},{ 1, 1}},

 /*Fm*/{{-1, 0},{ 0, 0},{ 0,-1},{-1,-1},{ 0, 1}},
 /*Lm*/{{ 0,-2},{ 0,-1},{ 0, 0},{ 0, 1},{ 1,-1}},
 /*Nm*/{{-2, 0},{-1, 0},{ 0, 0},{ 0,-1},{ 1,-1}},
 /*Pm*/{{-1, 0},{ 0, 0},{ 0,-1},{ 1, 0},{ 1,-1}},
 /*Ym*/{{-2, 0},{-1, 0},{ 0, 0},{ 0,-1},{ 1, 0}},
 /*Zm*/{{-1, 1},{-1, 0},{ 0, 0},{ 1, 0},{ 1,-1}},

 /*I*/{{ 0,-2},{ 0,-1},{ 0, 0},{ 0, 1},{ 0, 2}},
 /*T*/{{-1,-1},{ 0,-1},{ 1,-1},{ 0, 0},{ 0, 1}},
 /*U*/{{-1,-1},{-1, 0},{ 0, 0},{ 1, 0},{-1, 1}},
 /*V*/{{-1,-1},{-1, 0},{-1, 1},{ 0, 1},{ 1, 1}},
 /*W*/{{-1,-1},{-1, 0},{ 0, 0},{ 0, 1},{ 1, 1}},
 /*X*/{{-1, 0},{ 0,-1},{ 0, 0},{ 1, 0},{ 0, 1}},
 
};

struct PTS tri_struct[][3]={
  {{-1,0},{0,0},{0,1}},
  {{-1,0},{0,0},{1,0}},
};

//
int cw_rotate_T_STR()
{
  int k;
  for(k=0;k<t_f[t_work->cw_rotation].n;k++){
    if( point_T_STR.x+t_f[t_work->cw_rotation].delt[k].x <0 )return -1;
    if( point_T_STR.x+t_f[t_work->cw_rotation].delt[k].x >11 )return -1;
    if( field_array[point_T_STR.x+t_f[t_work->cw_rotation].delt[k].x]
                   [point_T_STR.y+t_f[t_work->cw_rotation].delt[k].y  ].buisy != 0)return -1;
  }
  t_work=&t_f[t_work->cw_rotation];
  return 0;
}
int ccw_rotate_T_STR()
{
  int k;
  for(k=0;k<t_f[t_work->cw_rotation].n;k++){
    if( point_T_STR.x+t_f[t_work->ccw_rotation].delt[k].x <0 )return -1;
    if( point_T_STR.x+t_f[t_work->ccw_rotation].delt[k].x >11 )return -1;
    if( field_array[point_T_STR.x+t_f[t_work->ccw_rotation].delt[k].x]
                   [point_T_STR.y+t_f[t_work->ccw_rotation].delt[k].y  ].buisy != 0)return -1;
  }
  t_work=&t_f[t_work->ccw_rotation];
  return 0;
}
//
int left_move_T_STR()
{
  int k;
  for(k=0;k<t_f[t_work->cw_rotation].n;k++){
    if( point_T_STR.x+t_work->delt[k].x-1 <0 )return -1;
    if( field_array[point_T_STR.x+t_work->delt[k].x-1]
		               [point_T_STR.y+t_work->delt[k].y  ].buisy != 0)return -1;
  }
  point_T_STR.x--;
  return 1;
}
int right_move_T_STR()
{
  int k;
  for(k=0;k<t_f[t_work->cw_rotation].n;k++){
    if( point_T_STR.x+t_work->delt[k].x+1 >11 )return -1;
    if( field_array[point_T_STR.x+t_work->delt[k].x+1]
		               [point_T_STR.y+t_work->delt[k].y  ].buisy != 0)return -1;
  }
  point_T_STR.x++;
  return 1;
}
int falling_T_STR(int *ndrop)
{
  int k;
  for(k=0;k<t_f[t_work->cw_rotation].n;k++){
    if( point_T_STR.y+t_work->delt[k].y-1 <0 )return -1;
    if( field_array[point_T_STR.x+t_work->delt[k].x]
		               [point_T_STR.y+t_work->delt[k].y-1].buisy != 0)return -point_T_STR.y;
  }
  *ndrop=0;
  point_T_STR.y--;
  for(k=0;k<t_f[t_work->cw_rotation].n;k++){
    if( point_T_STR.y+t_work->delt[k].y-1 <0 )*ndrop=-1;
    if( field_array[point_T_STR.x+t_work->delt[k].x]
		               [point_T_STR.y+t_work->delt[k].y-1].buisy != 0)*ndrop=-point_T_STR.y;
  }
  return 1;
}

//

void filling_T_STR()
{
  int i,j,ind_str;
  ind_str=0;

  // tetra ------------------------------
  for(i=0;i<N_T_STR_TETRA;i+=4){
    /* ------------------------------ 0*/
    t_f[i].cw_rotation=i+1;
    t_f[i].ccw_rotation=i+3;
    t_f[i].n=4;
    t_f[i].delt = calloc(t_f[i].n,sizeof(struct PTS));
    for(j=0;j<t_f[i].n;j++){
      t_f[i].delt[j].x=tetr_struct[ind_str++];
      t_f[i].delt[j].y=tetr_struct[ind_str++];
    }
    /* ------------------------------ 1*/
    t_f[i+1].cw_rotation=i+2;
    t_f[i+1].ccw_rotation=i+0;
    t_f[i+1].n=4;
    t_f[i+1].delt = calloc(t_f[i+1].n,sizeof(struct PTS));
    for(j=0;j<t_f[i].n;j++){
      t_f[i+1].delt[j].x=tetr_struct[ind_str++];
      t_f[i+1].delt[j].y=tetr_struct[ind_str++];
    }
    /* ------------------------------ 2*/
    t_f[i+2].cw_rotation=i+3;
    t_f[i+2].ccw_rotation=i+1;
    t_f[i+2].n=4;
    t_f[i+2].delt = calloc(t_f[i+2].n,sizeof(struct PTS));
    for(j=0;j<t_f[i].n;j++){
      t_f[i+2].delt[j].x=tetr_struct[ind_str++];
      t_f[i+2].delt[j].y=tetr_struct[ind_str++];
    }
    /* ------------------------------ 3*/
    t_f[i+3].cw_rotation=i+0;
    t_f[i+3].ccw_rotation=i+2;
    t_f[i+3].n=4;
    t_f[i+3].delt = calloc(t_f[i+3].n,sizeof(struct PTS));
    for(j=0;j<t_f[i].n;j++){
      t_f[i+3].delt[j].x=tetr_struct[ind_str++];
      t_f[i+3].delt[j].y=tetr_struct[ind_str++];
    }
    /* ----------------------------    */
  }
  ind_str=0;
  // penta ------------------------------
  for(i=N_T_STR_TETRA;i<N_T_STR_EXTRA;i+=4,++ind_str){
    /* ------------------------------ 0*/
    t_f[i].cw_rotation=i+1;
    t_f[i].ccw_rotation=i+3;
    t_f[i].n=5;
    t_f[i].delt = calloc(t_f[i].n,sizeof(struct PTS));
    for(j=0;j<t_f[i].n;j++){
      t_f[i].delt[j].x=pent_struct[ind_str][j].x;
      t_f[i].delt[j].y=pent_struct[ind_str][j].y;
    }
    /* ------------------------------ 1*/
    t_f[i+1].cw_rotation=i+2;
    t_f[i+1].ccw_rotation=i+0;
    t_f[i+1].n=5;
    t_f[i+1].delt = calloc(t_f[i+1].n,sizeof(struct PTS));
    for(j=0;j<t_f[i].n;j++){
      t_f[i+1].delt[j].x= pent_struct[ind_str][j].y;
      t_f[i+1].delt[j].y=-pent_struct[ind_str][j].x;
    }
    /* ------------------------------ 2*/
    t_f[i+2].cw_rotation=i+3;
    t_f[i+2].ccw_rotation=i+1;
    t_f[i+2].n=5;
    t_f[i+2].delt = calloc(t_f[i+2].n,sizeof(struct PTS));
    for(j=0;j<t_f[i+2].n;j++){
      t_f[i+2].delt[j].x=-pent_struct[ind_str][j].x;
      t_f[i+2].delt[j].y=-pent_struct[ind_str][j].y;
    }
    /* ------------------------------ 3*/
    t_f[i+3].cw_rotation=i+0;
    t_f[i+3].ccw_rotation=i+2;
    t_f[i+3].n=5;
    t_f[i+3].delt = calloc(t_f[i+3].n,sizeof(struct PTS));
    for(j=0;j<t_f[i+3].n;j++){
      t_f[i+3].delt[j].x=-pent_struct[ind_str][j].y;
      t_f[i+3].delt[j].y= pent_struct[ind_str][j].x;
    }
    /* ----------------------------    */
  }
  ind_str=0;
  for(i=N_T_STR_EXTRA;i<N_T_STR;i+=4,++ind_str){
    /* ------------------------------ 0*/
    t_f[i].cw_rotation=i+1;
    t_f[i].ccw_rotation=i+3;
    t_f[i].n=3;
    t_f[i].delt = calloc(t_f[i].n,sizeof(struct PTS));
    for(j=0;j<t_f[i].n;j++){
      t_f[i].delt[j].x=tri_struct[ind_str][j].x;
      t_f[i].delt[j].y=tri_struct[ind_str][j].y;
    }
    /* ------------------------------ 1*/
    t_f[i+1].cw_rotation=i+2;
    t_f[i+1].ccw_rotation=i+0;
    t_f[i+1].n=3;
    t_f[i+1].delt = calloc(t_f[i+1].n,sizeof(struct PTS));
    for(j=0;j<t_f[i].n;j++){
      t_f[i+1].delt[j].x= tri_struct[ind_str][j].y;
      t_f[i+1].delt[j].y=-tri_struct[ind_str][j].x;
    }
    /* ------------------------------ 2*/
    t_f[i+2].cw_rotation=i+3;
    t_f[i+2].ccw_rotation=i+1;
    t_f[i+2].n=3;
    t_f[i+2].delt = calloc(t_f[i+2].n,sizeof(struct PTS));
    for(j=0;j<t_f[i+2].n;j++){
      t_f[i+2].delt[j].x=-tri_struct[ind_str][j].x;
      t_f[i+2].delt[j].y=-tri_struct[ind_str][j].y;
    }
    /* ------------------------------ 3*/
    t_f[i+3].cw_rotation=i+0;
    t_f[i+3].ccw_rotation=i+2;
    t_f[i+3].n=3;
    t_f[i+3].delt = calloc(t_f[i+3].n,sizeof(struct PTS));
    for(j=0;j<t_f[i+3].n;j++){
      t_f[i+3].delt[j].x=-tri_struct[ind_str][j].y;
      t_f[i+3].delt[j].y= tri_struct[ind_str][j].x;
    }
    /* ----------------------------    */
  }
}
// tetr struct funct end

