/*
 * Yury P. Fedorchenko 2001-2011
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
//28 tetra + 72 penta + 8 tri
#define N_T_STR_TETRA 28
#define N_T_STR_PENTA 72
#define N_T_STR_EXTRA 100
#define N_T_STR 108

struct FIELD {
  int x,y ;
  int buisy;
};
struct PTS{
  int x,y;
};
struct T_STR{
  int n;
  int cw_rotation,ccw_rotation;
  struct PTS *delt;
};
struct s_button{
  const char*name;
  int x,y;
  int size;
  int inv;
  int (* pfun)(void);
};

int but_inside(struct s_button*,int x,int y);
int but_click(struct s_button*);
void but_draw(struct s_button*);
//
int cw_rotate_T_STR();
int ccw_rotate_T_STR();
int left_move_T_STR();
int right_move_T_STR();
int falling_T_STR(int*);
void filling_T_STR();

void update_hscr(int score,int level,int lines);
